Summary: libXt - X Toolkit Intrinsics library
Name: libXt
Version: 1.2.1
Release: 12%{?dist}2a
License: Free Software Foundattion
Group: User Interface/X
URL: http://www.x.org

Source0: https://www.x.org/archive/individual/lib/libXt-1.2.1.tar.bz2
Patch0: localhost:/libXt-1.2.1-flat_namespace.patch

BuildRequires: pkgconfig
BuildRequires: xorg-x11-util-macros
BuildRequires: xorg-x11-proto-devel
BuildArch:    fat

%description
X Toolkit Intrinsics library, need for motif, etc.

%prep
%setup -q -c %{name}-%{version}
mv %{name}-%{version} ARM64
pushd arm64
%ifos darwin
%patch0 -p1 -b .flatn
%endif
popd
cp -a ARM64 X86_64


%build
pushd ARM64
export CFLAGS="-O3 -arch arm64 -I%{_includedir} -I/opt/X11/include"
export CPPFLAGS="-arch arm64 -I%{_includedir} -I/opt/X11/include"
export CXXFLAGS="$CFLAGS"
export FFLAGS="$CFLAGS"
export FCFLAGS="$CFLAGS"
export LDFLAGS="-arch arm64 -L%{_libdir} -L/opt/X11/lib"

./configure \
        --host=%{_rpm_platform_arm64} \
        --build=%{_rpm_platform_arm64} \
        --target=%{_rpm_platform_arm64} \
        --prefix=/opt/X11
make %{?_smp_mflags}
popd
pushd X86_64
export CFLAGS="-O3 -arch x86_64 -I%{_includedir} -I/opt/X11/include"
export CPPFLAGS="-arch x86_64 -I%{_includedir} -I/opt/X11/include"
export CXXFLAGS="$CFLAGS"
export FFLAGS="$CFLAGS"
export FCFLAGS="$CFLAGS"
export LDFLAGS="-arch x86_64 -L%{_libdir}"
./configure \
	--host=%{_rpm_platform_x86_64} \
	--build=%{_rpm_platform_x86_64} \
	--target=%{_rpm_platform_x86_64} \
        --prefix=/opt/X11
make %{?_smp_mflags}
popd

%install
rm -rf $RPM_BUILD_ROOT
PWD=`pwd`
pushd ARM64
rm -rf ${PWD}-root
mkdir -p ${PWD}-root
#make install DESTDIR=%{buildroot}
make install INSTALL="install -p" DESTDIR=${PWD}-root
popd
pushd X86_64
rm -rf ${PWD}-root
mkdir -p ${PWD}-root
make install INSTALL="install -p" DESTDIR=${PWD}-root
popd

## Make Universal Binaries
filelist=$(find ./ARM64-root -type f | xargs file | sed -e 's,^\./ARM64-root/,,g' | \
        grep -E \(Mach-O\)\|\(ar\ archive\) |sed -e 's,:.*,,g' -e '/\for\ architecture/d')

for i in $filelist
do
        /usr/bin/lipo -create ARM64-root/$i X86_64-root/$i -output `basename $i` && \
        (cp -f `basename $i` ARM64-root/$i) || :
done

# check header files
for i in `find ARM64-root -name "*.h" -type f`
do
        TARGET=`echo $i | sed -e "s,.*ARM64-root,,"`
        TEMP=`diff -u ARM64-root/$TARGET X86_64-root/$TARGET > /dev/null || echo different`
        if [ -n "$TEMP" ]; then
                mv X86_64-root/$TARGET ARM64-root/${TARGET%.*}-x86_64.h
                mv ARM64-root/$TARGET ARM64-root/${TARGET%.*}-arm64.h
                FILE=${TARGET##*/}
                FILE=${FILE%.*}
cat <<EOF > ARM64-root/$TARGET
#if defined (__arm64__)
#include "${FILE}-arm64.h"
#elif defined( __x86_64__ )
#include "${FILE}-x86_64.h"
#endif
EOF
        fi
done

# install
mkdir -p %{buildroot}
tar cf - -C ARM64-root . | tar xpf - -C %{buildroot}

%clean
rm -rf $RPM_BUILD_ROOT

%post
echo "Back up Xquartz's /opt/X11/lib/libXt.6.dylib as"
echo "cd /opt/X11/lib"
echo "sudo mkdir libXt.orig"
echo "sudo mv libXt.6.dylib libXt.orig/"
echo "and make a symlink as follows:"
echo "cd /opt/X11/lib"
echo "sudo ln -s libXt.6.0.0.dylib libXt.6.dylib"

%postun
echo "Restore the original /opt/X11/lib/libXt.6.dylib"
echo "for instance as"
echo "cd /opt/X11/lib"
echo "sudo cp -pf libXt.orig/libXt.6.dylib ."

%files
%ifnos darwin
%defattr(-,root,root,-)
%else
%defattr(-,root,wheel,-)
%endif
%doc COPYING ChangeLog
/opt/X11/lib/libXt.6.0.0.dylib

%changelog
* Wed Mar 16 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 1.2.1-12hepx2a
- 4th build and release on MacOS 12 for M1 and Intel Macs (fat)
- built with OSXWS 12beta

* Sat Feb 26 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 1.2.1-12hepx1d
- 3rd build and release on MacOS 12
- built with OSXWS 12beta

* Mon Jan 31 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 1.2.1-12hepx1c
- 3rd build and release on MacOS 12
- added flat_namespace patch.
- modified %post and %postun just to tell suggested user action
- built with OSXWS 11

* Sun Jan 30 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 1.2.1-12hepx1b
- 2nd build and release on MacOS 12
- now with flat_namespace

* Fri Jan 28 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 1.2.1-12hepx1a
- 1st build and release on MacOS 12
